#include <SMD.h>
#define LED         PIN_A1
#define EEPROM_SDA  PIN_A4
#define EEPROM_SCL  PIN_A5
#include "My241025.C"
//#rom 0xF00000 = {0,0}
#define CLK PIN_A2
#define DAT PIN_A0
#define MAX    70

int8 B=0;
int1 F=0;
int8 rear=0;
int8 front=0;
int8 BUF[MAX];
int16 count=0;
int32 IND=0;

#int_EXT
void  EXT_isr(void) 
{
   if(B==0)
   {
      if(!input(DAT))
      {
         B++;
      }
      //else
         //ext_int_edge(0, L_TO_H );
   }
   else
   {
      
      if(B<9)
      {      
         if(input(DAT))
            bit_set(BUF[front],(B-1));
         else
            bit_clear(BUF[front],(B-1));
         B++;
      }
      else
      {
         if(B==10)
         {
            front=(front+1)%MAX;
            BUF[front]=0x00;
            output_low(LED);
            B=0; 
            //ext_int_edge(0, H_TO_L );
         }
         else
            B++;
      }
      
   }
}



void main()
{
   SETUP_WDT(WDT_OFF);
   setup_adc(ADC_OFF);
   setup_adc_ports(NO_ANALOGS);
   enable_interrupts(INT_EXT);
   enable_interrupts(GLOBAL);
    setup_oscillator(OSC_16MHZ|OSC_INTRC|OSC_PLL_ON,0);
   ext_int_edge(0, H_TO_L );   // Sets up EXT
   output_high(LED);
   init_ext_eeprom();
   //Example blinking LED program
   IND=make32(read_ext_eeprom(3),read_ext_eeprom(2),read_ext_eeprom(1),read_ext_eeprom(0));
    while(1)
    {
       do
       {
          count=0;
          while(B==0 && count<500){
          delay_ms(1);
          count++;
          }
       }while(B!=0);
       while(rear!=front)
       {
         output_high(LED);
         write_ext_eeprom(IND+4,BUF[rear]);
         //output_low(LED);
         rear=(rear+1)%MAX;
         IND++;
         write_ext_eeprom(0,make8(IND,0));
         write_ext_eeprom(1,make8(IND,1));
         write_ext_eeprom(2,make8(IND,2));
         write_ext_eeprom(3,make8(IND,3));
       }
    }
   
}
